import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * Utility functions. You can ignore this.
 */
public final class Util {

	public static final <A> String showCharSet(Set<A> cs) {
		StringBuilder sb = new StringBuilder();
		List<A> l = cs.stream().sorted().collect(Collectors.toList());
		boolean first = true;
		for (A c : l) {
			if (first)
				first = false;
			else
				sb.append(", ");
			sb.append(c);
		}
		return sb.toString();
	}

	public static final <T extends Comparable<? super T>> int compareLexicographic(Iterator<? extends T> left,
			Iterator<? extends T> right) {
		while (left.hasNext() && right.hasNext()) {
			int compare = left.next().compareTo(right.next());
			if (compare != 0) {
				return compare;
			}
		}
		if (left.hasNext()) {
			return 1;
		}
		if (right.hasNext()) {
			return -1;
		}
		return 0;
	}

	public static final List<String> collectionToString(Collection<?> list) {
		return list.stream().map(Object::toString).collect(Collectors.toList());
	}
	
}
